#include "raytracer.h"

Vec3f RayTracer::
trace_ray(const Ray& ray, float tmin, float tmax, int depth_left) const
{
   float t;
   Vec3f normal;
   Material material;

   // find the first intersection with geometry in the scene
   if(shape.intersect(ray, tmin, tmax, t, normal, material)){
      // @@@ ADD CODE HERE
      // At this point you know there was an intersection with the ray,
      // and you're given the t value at which the first intersection occurs
      // along with the surface normal and material at that point.
      // You need to compute the color based on that material, possibly tracing
      // shadow rays to directed light sources for the diffuse component and
      // a recursive traced ray for a mirror component.
      // @@@

      return Vec3f(1,1,1); // this is not the correct code, but for now stops the compiler complaining

   }else{ // if there was no intersection at all, return a default black
      return Vec3f(0,0,0);
   }
}
